%define STDC_VERSION 2.9.0
%define EGCS_VERSION 1.1.2
%{expand:%%define mdk_version %(A=$(awk '{print $4}' /etc/mandrake-release); if [ -n "$A" ];then echo $A;else echo Cooker;fi)}

Summary:	The GNU Compiler Collection
Name:		egcs
Version:	%{EGCS_VERSION}
Release:	44mdk
License:	GPL
Group:		Development/C

Source0:	ftp://egcs.cygnus.com/pub/egcs/releases/egcs-%{EGCS_VERSION}/egcs-%{EGCS_VERSION}.tar.bz2
Source1:	egcs-libstdc++-compat.tar.bz2

Patch0:		ftp://ftp.varesearch.com/pub/support/hjl/egcs/egcs-1.1.2-linux.patch.bz2
Patch1:		egcs-1.1.2-davem.patch.bz2
Patch2:		egcs-1.1.2-gcse.patch.bz2
Patch3:		egcs-1.1.2-cpu.patch.bz2
Patch4:		egcs-1.1.2-integrate.patch.bz2
Patch5:		egcs-1.1.2-expr.patch.bz2
Patch6:		egcs-1.1.2-strlen.patch.bz2
Patch7:		egcs-1.1.2-warn.patch.bz2
Patch8:		egcs-1.1.2-addressof.patch.bz2
Patch9:		egcs-1.1.2-fold.patch.bz2
Patch10:	egcs-1.1.2-asm.patch.bz2
Patch11:	egcs-libio.patch.bz2

Patch12:	egcs-1.1.2-glibc-2.1.94.patch.bz2

Buildroot:	%_tmppath/%name-%version-%release-root
Url:		http://egcs.cygnus.com/
Requires:	binutils >= 2.9.1.0.21
BuildRequires:	gcc, gcc-cpp, tetex-xdvi, texinfo
Prereq:		/sbin/install-info
ExcludeArch: ia64

%description
This package includes a compiler that can be to generate binaries that
will run on older Linux-Mandrake systems (namely Linux-Mandrake 6.1).
a
This package includes the C compiler and required compiler libraries for
those systems.

%package c++
Summary:	C++ support for the gcc compiler
Group:		Development/C++
Requires:	egcs = %version-%release, egcs-libstdc++
Obsoletes:  %{name}-libstdc++
Provides:   %{name}-libstdc++

%description c++
This package adds C++ support to the GNU C compiler. It includes
support for most of the current C++ specification, including templates
and exception handling. It does include the static standard C++
library and C++ header files; the library for dynamically linking
programs is available separately.

%package objc-devel
Summary:	Objective C support for the gcc compiler
Group:		Development/Other
Requires:	egcs-objc = %version-%release
Obsoletes:	egcs-libobjc

%description objc-devel
Egcs-objc-devel provides Objective C includes for the GNU C compiler (gcc).
Mainly used on systems running NeXTSTEP, Objective C is an 
object-oriented derivative of the C language.

%package objc
Summary:	Objective C support for the gcc compiler
Group:		Development/Other
Requires:	egcs = %version-%release

%description objc
Egcs-objc provides Objective C support for the GNU C compiler (gcc).
Mainly used on systems running NeXTSTEP, Objective C is an 
object-oriented derivative of the C language.

Install egcs-objc if you are going to do Objective C development and
you would like to use the gcc compiler.  You'll also need gcc, which
is included in the egcs package.

%package g77
Summary:	Fortran 77 support for the gcc compiler
Group:		Development/Other
Requires:	egcs = %version-%release
Prereq:		/sbin/install-info

%description g77
The egcs-g77 package provides support for compiling Fortran 77
programs with the GNU gcc compiler.

You should install egcs-g77 if you are going to do Fortran development
and you would like to use the gcc compiler.  You will also need gcc,
which is included in the egcs package.

%package cpp
Summary:	The GNU C-Compatible Compiler Preprocessor
Group:		Development/C
Prereq:		/sbin/install-info

%description cpp
Cpp (or cccp) is the GNU C-Compatible Compiler Preprocessor.
Cpp is a macro processor which is used automatically
by the C compiler to transform your program before actual
compilation. It is called a macro processor because it allows
you to define macros, abbreviations for longer
constructs.

The C preprocessor provides four separate functionalities: the
inclusion of header files (files of declarations that can be
substituted into your program); macro expansion (you can define macros,
and the C preprocessor will replace the macros with their definitions
throughout the program); conditional compilation (using special
preprocessing directives, you can include or exclude parts of the
program according to various conditions); and line control (if you use
a program to combine or rearrange source files into an intermediate
file which is then compiled, you can use line control to inform the
compiler about where each source line originated).

You should install this package if you are a C programmer and you use
macros.

%prep

%setup -q -n %{name}-%{EGCS_VERSION}
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p0
%patch11 -p0
%patch12 -p1

mkdir compat
bzcat %{SOURCE1}|tar xf - -C compat
cd gcc ; autoconf ; cd ..

perl -pi -e 's/\)/ \/ Linux-Mandrake %{mdk_version}\)/' gcc/version.c gcc/f/version.c

%build
rm -rf obj-%{_target_platform}
mkdir obj-%{_target_platform}
cd obj-%{_target_platform}
../configure  --prefix=%_prefix \
	      --enable-shared \
	      --enable-threads \
	      %{_target_platform}

PATH=$PATH:/sbin:/usr/sbin
# gperf is most likely broken on alpha and sparc 
touch  ../gcc/c-gperf.h
make MAKEINFO="makeinfo --no-split"  bootstrap-lean
make MAKEINFO="makeinfo --no-split" info

%install
cd obj-%{_target_platform}
PATH=$PATH:/sbin:/usr/sbin
make install \
	prefix=$RPM_BUILD_ROOT/usr \
	mandir=$RPM_BUILD_ROOT%{_mandir}/man1 \
	MAKEINFO="makeinfo --no-split" 
FULLVER=$($RPM_BUILD_ROOT%{_bindir}/gcc --version)
FULLPATH=$(dirname $RPM_BUILD_ROOT%{_libdir}/gcc-lib/%{_target_platform}/$FULLVER/cc1)

file $RPM_BUILD_ROOT/usr/bin/* | grep ELF | cut -d':' -f1 | xargs strip -R .comment || :
strip -R .comment $FULLPATH/{cc1,cc1obj,cc1plus,cpp,f771,collect2}

LIB_ARCH=`echo $RPM_ARCH | sed 's/i?86/i386/'`
[ -d ../compat/$LIB_ARCH ] && install -m 755 ../compat/$LIB_ARCH/* $RPM_BUILD_ROOT/usr/lib/

# build a fake libstdc++.so.2.9 library for compatibility with other distros
pushd $RPM_BUILD_ROOT/usr/lib ; {
	touch foo.c
	../bin/g++ -B gcc-lib/*/*/ -fPIC -L. -shared -o libstdc++.so.2.9.dummy \
		-Wl,-soname,libstdc++.so.2.9
	rm -f foo.c
} ; popd

cat >$RPM_BUILD_ROOT%{_bindir}/egcs-version <<EOF
#!/bin/sh
echo "$FULLVER"
EOF


mv -f $RPM_BUILD_ROOT/usr/bin/gcc $RPM_BUILD_ROOT/usr/bin/kgcc
mv -f $RPM_BUILD_ROOT/usr/bin/g++ $RPM_BUILD_ROOT/usr/bin/kg++

mkdir -p $RPM_BUILD_ROOT/lib
ln -sf ../${FULLPATH##$RPM_BUILD_ROOT/}/cpp $RPM_BUILD_ROOT/lib/cpp
ln -s cpp %buildroot/${FULLPATH##$RPM_BUILD_ROOT}/cpp0
ln -s cpp %buildroot/${FULLPATH##$RPM_BUILD_ROOT}/tradcpp0

%clean
rm -rf $RPM_BUILD_ROOT

%post c++ -p /sbin/ldconfig
%postun c++ -p /sbin/ldconfig

%files
%defattr(-,root,root)
%doc README* COPYING COPYING.LIB
%dir %{_libdir}/gcc-lib
%dir %{_libdir}/gcc-lib/%{_target_platform}
%dir %{_libdir}/gcc-lib/%{_target_platform}/egcs-*
%dir %{_libdir}/gcc-lib/%{_target_platform}/egcs-*/include
%{_bindir}/kgcc
%attr(755,root,root) %{_bindir}/egcs-version


%{_libdir}/gcc-lib/%{_target_platform}/egcs-*/SYSCALLS.c.X
%{_libdir}/gcc-lib/%{_target_platform}/egcs-*/cc1
%{_libdir}/gcc-lib/%{_target_platform}/egcs-*/collect2
%{_libdir}/gcc-lib/%{_target_platform}/egcs-*/libgcc.a
%{_libdir}/gcc-lib/%{_target_platform}/egcs-*/libgcc.map
%{_libdir}/gcc-lib/%{_target_platform}/egcs-*/specs

%ifnarch alpha
%{_libdir}/gcc-lib/%{_target_platform}/egcs-*/*.o
%endif

/usr/%{_target_platform}

%{_libdir}/gcc-lib/%{_target_platform}/egcs-*/include/README
%{_libdir}/gcc-lib/%{_target_platform}/egcs-*/include/float.h
%{_libdir}/gcc-lib/%{_target_platform}/egcs-*/include/iso646.h
%{_libdir}/gcc-lib/%{_target_platform}/egcs-*/include/limits.h
%{_libdir}/gcc-lib/%{_target_platform}/egcs-*/include/proto.h
%{_libdir}/gcc-lib/%{_target_platform}/egcs-*/include/stdarg.h
%{_libdir}/gcc-lib/%{_target_platform}/egcs-*/include/stdbool.h
%{_libdir}/gcc-lib/%{_target_platform}/egcs-*/include/stddef.h
%{_libdir}/gcc-lib/%{_target_platform}/egcs-*/include/syslimits.h
%{_libdir}/gcc-lib/%{_target_platform}/egcs-*/include/va-*.h
%{_libdir}/gcc-lib/%{_target_platform}/egcs-*/include/varargs.h
%ifarch ppc
%{_libdir}/gcc-lib/%{_target_platform}/egcs-*/include/*-asm.h
%endif

%files cpp
%defattr(-,root,root)
%{_libdir}/gcc-lib/%{_target_platform}/egcs-*/cpp*
%{_libdir}/gcc-lib/%{_target_platform}/egcs-*/tradcpp*

%files c++
%defattr(-,root,root)
%{_bindir}/kg++
%{_libdir}/gcc-lib/%{_target_platform}/egcs-*/cc1plus
%{_libdir}/gcc-lib/%{_target_platform}/egcs-*/libstdc*
%{_libdir}/gcc-lib/%{_target_platform}/egcs-*/include/exception
%{_libdir}/gcc-lib/%{_target_platform}/egcs-*/include/new
%{_libdir}/gcc-lib/%{_target_platform}/egcs-*/include/typeinfo
%{_libdir}/gcc-lib/%{_target_platform}/egcs-*/include/new.h
%{_includedir}/g+*
%ifarch ppc
%{_libdir}/nof
%endif
/usr/lib/libstdc++-2-libc*-%{STDC_VERSION}.so
%ifnarch ppc
/usr/lib/libstdc++-libc6.1-2.so.3
%endif
/usr/lib/libstdc++.so.2.8.0
%ifnarch ppc
/usr/lib/libstdc++.so.2.7.2.8
/usr/lib/libg++.so.2.7.2.8
%endif
/usr/lib/libstdc++.so.2.9.dummy

%files objc
%defattr(-,root,root)
%{_libdir}/gcc-lib/%{_target_platform}/egcs-*/cc1obj

%files objc-devel
%defattr(-,root,root)
%{_libdir}/gcc-lib/%{_target_platform}/egcs-*/libobjc.a
%{_libdir}/gcc-lib/%{_target_platform}/egcs-*/include/objc

%files g77
%defattr(-,root,root)
%{_libdir}/gcc-lib/%{_target_platform}/egcs-*/f771
%{_libdir}/gcc-lib/%{_target_platform}/egcs-*/libg2c.a
%{_libdir}/gcc-lib/%{_target_platform}/egcs-*/include/g2c.h


%changelog
* Tue Apr 10 2001 David BAUDENS <baudens@mandrakesoft.com> 1.1.2-44mdk
- Exclude libstdc++-libc6.1-2.so.3 on PPC (not needed)
- Remove useless sources (and win 9 MB in SRPM)

* Sun Apr  8 2001 Chmouel Boudjnah <chmouel@mandrakesoft.com> 1.1.2-43mdk
- Merge egcs-libstdc++ and egcs-c++.
- Add libstdc++-libc6.1-2.so.3 link for compat older version.

* Thu Apr 05 2001 Francis Galiegue <fg@mandrakesoft.com> 1.1.2-42mdk
- ExcludeArch: ia64

* Sat Mar 03 2001 Chmouel Boudjnah <chmouel@mandrakesoft.com> 1.1.2-41mdk
- Add g++-2.95 files to compat.
- Add link to tradcpp0.

* Mon Jan 08 2001 David BAUDENS <baudens@mandrakesoft.com> 1.1.2-40mdk
- BuildRequires: texinfo
- Fix Requires

* Mon Dec 18 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 1.1.2-39mdk
- Don't do BuildRequires: %%{name}-cpp (dadou sux).

* Sun Dec 17 2000 David BAUDENS <baudens@mandrakesoft.com> 1.1.2-38mdk
- Add PPC to egcs-libstdc++-compat to be able to compile old libstdc++
  applications (and to be able to build this package on PPC)
- BuildRequires: tetex-xdvi

* Tue Dec  5 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 1.1.2-37mdk
- Add egcs-libstdc++ to be able to compile old libstdc++ applications.

* Thu Nov  9 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 1.1.2-36mdk
- Put Linux-Mandrake version in banner.
- Fix description.

* Thu Nov  9 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 1.1.2-35mdk
- Fix build with last glibc.
- Fix completely kgcc (don't use script use binary instead).

* Sun Oct 15 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 1.1.2-34mdk
- Add cpp0 link to cpp to get works kgcc when not with the kernel.

* Mon Oct  2 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 1.1.2-33mdk
- Bzip2 patch.
- Requires: egcs-cpp.
- chmod +x kg* script (silly me :p).

* Mon Oct  2 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 1.1.2-32mdk
- s|compat-egcs|kgcc|; to allow build last 2.2.18 kernel with safe
  compiler.

* Tue Jul 25 2000 Thierry Vignaud <tvignaud@mandrakesoft.com> 1.1.2-31mdk
- split out egcs-objc-devel

* Wed Jul 19 2000 Thierry Vignaud <tvignaud@mandrakesoft.com> 1.1.2-29mdk
- BM
- use new macros

* Thu Apr 27 2000 Thierry Vignaud <tvignaud@mandrakesoft.com> 1.1.2-28mdk
- rename egcs to avoid configuration collision in bad configure scripts
  (Giuseppe Ghibo). Idem for egcs++
- merge in RH patches

* Tue Apr 18 2000 Warly <warly@mandrakesoft.com> 1.1.2-27mdk
- fixe groups

* Thu Mar 30 2000 Thierry Vignaud <tvignaud@mandrakesoft.com>
- add egcs & egcs++ scripts as Lord Chmou asked

* Thu Mar 23 2000 Thierry Vignaud <tvignaud@mandrakesoft.com>
- simplify the spec by means of spechelper
- new naming convention

* Sat Nov 13 1999 Giuseppe Ghib <ghibo@linux-mandrake.com>
- build to have egcs coexisting with gcc 2.95.X.

* Wed Sep 8 1999 Jim Kingdon <http://developer.redhat.com>
- Fix egcs-1.1.2-cpu.patch so that it works if more than one option
  from a set is specified.

* Thu Sep 3 1999 David S. Miller <davem@redhat.com>
- Fixup egcs-1.1.2-expr.patch to modify c-parse.in

* Wed Sep 1 1999 Jim Kingdon <http://developer.redhat.com>
- Add egcs-1.1.2-strlen.patch (fixes compiler core dump on certain strlen
  invocations) and egcs-1.1.2-warn.patch (makes -Wpointer-arith work
  with glibc-2.1.2-7).

* Thu Aug 19 1999 Jim Kingdon <http://developer.redhat.com>
- Replace egcs-1.1.2-global.patch (which is bogus according to Richard
  Henderson) with egcs-1.1.2-fixtrunc.patch (which fixes the same bug,
  and looks more likely to be right).

* Thu Aug 12 1999 Cristian Gafton <gafton@redhat.com>
- build a dummy libstsdc++.so.2.9 library to maintain compatibility with
  other distribution not using HJ's Linux patches.

* Tue Jul 30 1999 Jim Kingdon <http://developer.redhat.com>
- Add egcs-1.1.2-expr.patch to fix 3971 in bugzilla.

* Tue Jul 20 1999 Jim Kingdon <http://developer.redhat.com>
- Add egcs-1.1.2-global.patch, fixes core dumps.

* Mon Jul 12 1999 Cristian Gafton <gafton@redhat.com>
- improved CPU handling patch

* Thu Jun 24 1999 Cristian Gafton <gafton@redhat.com>
- added patch from rth to stop cpp from defining __i486__ macros on -m486
  (it is not supposed to according to the info page, and this makes code
  compiled with -m486 not run on i386 anymore)

* Mon May 17 1999 Matt Wilson <msw@redhat.com>
- added patch from Dave Miller

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com> 
- auto rebuild in the new build environment (release 12)

* Wed Mar 17 1999 Cristian Gafton <gafton@redhat.com>
- version 1.1.2
- added patch from davem

* Fri Mar 12 1999 Cristian Gafton <gafton@redhat.com>
- version 1.1.2pre3
